package com.acme.server;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Session;

import com.acme.client.AddressBookService;
import com.acme.client.Contact;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;

/*
 * This servlet implements GWT remote procedure calls by
 * extending the GWT's RemosteServiceServlet class. It also
 * implements the com.acme.client.AddressBookService 
 * interface.
 */
public class AddressBookServiceImpl extends RemoteServiceServlet
                         implements AddressBookService {
   private static final long serialVersionUID = 1L;
   private static final String QUERY_TEXT = "from Contact";
   
   /*
    * Get the contacts from the database.
    */
   public List getContacts() {
      List contacts = null;
      try {
         Session session = HibernateUtil.getSessionFactory()
                                 .getCurrentSession(); 
         session.beginTransaction(); 
         contacts = session.createQuery(QUERY_TEXT).list();
         session.getTransaction().commit();   
     } catch (HibernateException e) {
        e.printStackTrace();
     }
     return contacts;
    }
   
    /*
     * Save a contact in the database.
     */
    public void saveContact(Contact saveMe) {
      try {
         Session session = HibernateUtil.getSessionFactory()
                                  .getCurrentSession(); 
         session.beginTransaction(); 
         session.save(saveMe);
         session.getTransaction().commit();   
      } catch (HibernateException e) {
         e.printStackTrace();
      }       
    }
    
    /*
     * Update a contact in the database.
     */    
    public void updateContact(Contact updateMe) {
      try {
         Session session = HibernateUtil.getSessionFactory()
                                  .getCurrentSession(); 
         session.beginTransaction(); 
         session.update(updateMe);
         session.getTransaction().commit();   
      } catch (HibernateException e) {
         e.printStackTrace();
      }       
    }
    
    /*
     * Delete a contact from the database.
     */    
    public void deleteContact(Contact deleteMe) {
      try {
         Session session = HibernateUtil.getSessionFactory()
                                  .getCurrentSession(); 
         session.beginTransaction(); 
         session.delete(deleteMe);
         session.getTransaction().commit();   
      } catch (HibernateException e) {
         e.printStackTrace();
      }       
    }
}


