package com.acme.client;

import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/*
 * A composite widget that displays a trip's information.
 */
public class TripPanel extends Composite {
   public TripPanel(Trip trip) {
      HorizontalPanel hp = new HorizontalPanel();
      Widget infoPanel = createInfoPanel(trip);
      hp.add(new Image(trip.getImage()));
      hp.add(infoPanel);      
      
      // Beware: you cannot call setStyles() before initWidget()!
      initWidget(hp);
      setStyles(hp, infoPanel);
   }
   private Widget createInfoPanel(Trip trip) {
      VerticalPanel panel = new VerticalPanel();
      panel.add(new HTML("<strong>By:</strong> " 
              + trip.getYahooId()));
      panel.add(new HTML(getSummary(trip)));
      int duration = trip.getDuration();
      panel.add(new Label((new Integer(duration).toString()) 
                         + " days"));
      panel.add(new HTML("<a href='" + trip.getUrl() 
                                   + "'>read more...</a>"));
      panel.setStyleName("tripSummary");
      return panel;
   }
   private String getSummary(Trip trip) {
      String summary = trip.getSummary();
      if (summary.length() > 100) {
         summary = summary.substring(0, 99) + "...";
      }
      return "<strong>Summary:</strong> " + summary;
   }
   private void setStyles(Widget horizontalPanel, 
                          Widget infoPanel) {
      addStyleName("tripPanel");
      horizontalPanel.addStyleName("tripPanelRoot");
      infoPanel.addStyleName("tripPanelInfo");
   }
}
