package com.acme.client.dnd;

import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.FocusPanel;
import com.google.gwt.user.client.ui.MouseListener;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.Widget;

/*
 * When you add widgets to this extension of 
 * {@link AbsolutePanel}, the widgets are wrapped
 * in a {@link FocusPanel} that's added to
 * the panel. This is necessary because not all 
 * GWT widgets support mouse listeners. Buttons, 
 * for instance, do not support mouse listeners, 
 * so if you added a button directly to this panel,
 * you couldn't drag it because you can't attach a 
 * mouse listener to it.
 * 
 * So, we drag around focus panels, each of which 
 * contains a single widget. Of course, that widget 
 * could be (and often is) a panel, with a hierarchy 
 * of widgets underneath it.
 *
 */
public class DragPanel extends AbsolutePanel {
   private static final MouseListener defaultDragger =
      new FollowsMouseDragger();

   public void add(Widget widget) {
      super.add(wrapWidget(widget));
   }
   public void add(Widget widget, int x, int y) {
       super.add(wrapWidget(widget), x, y);
   }
   
   protected Panel wrapWidget(Widget widget) {
      FocusPanel fp = new FocusPanel();
      fp.add(widget);
      fp.addMouseListener(getMouseDragger(widget));
      return fp;
   }
   
   /* Subclasses of {@link DragPanel} will most likely override
    * getMouseDragger() to provide a custom mouse dragger.
    * See {@link ListDragPanel} for an example of that.
    */
   protected MouseListener getMouseDragger(Widget widget) {
      return defaultDragger;
   }
}