package com.acme.server;

import javax.xml.parsers.DocumentBuilderFactory;
import com.acme.client.TripService;
import com.acme.client.Trip;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import java.io.File;

public class TripServiceImpl extends RemoteServiceServlet
                          implements TripService {
    private static final long serialVersionUID = 1L;

    public Trip[] getTrips(String location) {
        return getTripsFromDocument(getTripsDocument());
    }
    private Trip[] getTripsFromDocument(Document document) {
        NodeList results = (NodeList)document
            					.getElementsByTagName("Result");
        Trip[] trips = new Trip[results.getLength()];
        
        for (int i=0; i < results.getLength(); ++i) {
        	Element result = (Element)results.item(i);
        	
        	Trip trip = new Trip(getElementValue(result, "Title"));
        	trip.setDuration(Integer.parseInt(
        			getElementValue(result, "Duration")));
        	trip.setSummary(getElementValue(result, "Summary"));
        	trip.setImage(getImage(result));
        	trip.setUrl(getElementValue(result, "Url"));
        	trip.setYahooId(getElementValue(result, "YahooID"));
        	
        	trips[i] = trip;
        }
        return trips;
    }
    private Document getTripsDocument() {
        Document document = null;
        try {
            document = DocumentBuilderFactory.newInstance()
            .newDocumentBuilder()
            	.parse(new File ("tripSearch.xml"));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return document;
    }
    private String getElementValue(Element result, 
			   String elementName) {
    	Element element = (Element)result
    					.getElementsByTagName(elementName).item(0);

    	return element.getFirstChild().getNodeValue();
	}
    private String getImage(Element element) {
    	Element image = (Element)element
    						.getElementsByTagName("Image").item(0);
    	Element url = (Element)image
    						.getElementsByTagName("Url").item(0);
    	return url.getFirstChild().getNodeValue();
    }
}