package com.acme.client;

import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class TripPanel extends SimplePanel {
   public TripPanel(Trip trip) {
      HorizontalPanel root = new HorizontalPanel();
      Widget infoPanel = createInfoPanel(trip);
      root.add(new Image(trip.getImage()));
      root.add(infoPanel);      
      setStyles(root, infoPanel);
      add(root);
   }
   private Widget createInfoPanel(Trip trip) {
      VerticalPanel panel = new VerticalPanel();
      panel.add(new HTML("<strong>By:</strong> " 
                         + trip.getYahooId()));
      panel.add(new HTML(getSummary(trip)));
      int duration = trip.getDuration();
      panel.add(new Label(
          (new Integer(duration).toString()) + " days"));
      panel.add(new HTML("<a href='" 
                   + trip.getUrl() + "'>read more...</a>"));
      return panel;
   }
   private String getSummary(Trip trip) {
      String summary = trip.getSummary();
      if (summary.length() > 100) {
         summary = summary.substring(0, 99) + "...";
      }
      return "<strong>Summary:</strong> " + summary;
   }
   private void setStyles(Widget root, Widget infoPanel) {
      addStyleName("tripPanel");
      root.addStyleName("tripPanelRoot");
      infoPanel.addStyleName("tripPanelInfo");
   }
}
