package com.acme.client.dnd;

import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.Widget;

/*
 * A mouse dragger that lets the widget being dragged follow
 * the mouse. {@link}AbstractMouseDragger sends us proposed 
 * coordinates for the widget's next position in 
 * {@link}getNextLeft() and {@link}getNextTop(). 
 * This dragger accepts the proposed coordinates
 * , provided that the widget stays within it's panel. If
 * the widget is about to slide off the edge of the panel, 
 * this listener adjusts its position to keep it in bounds.
 * 
 */

public class FollowsMouseDragger extends AbstractMouseDragger {
   protected int getNextLeft(int proposedLeft, Widget widget) {
      return checkLeftBounds(proposedLeft, widget);
   }
   protected int getNextTop(int proposedTop, Widget widget) {
      return checkTopBounds(proposedTop, widget);
   }
}
